commit f1789989ca265abaa246592cd4223cc3ca89b361
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Fri Feb 24 11:05:27 2023 +0100

    cgraphclones: Don't share DECL_ARGUMENTS between thunk and its artificial thunk [PR108854]
    
    The following testcase ICEs on x86_64-linux with -m32.  The problem is
    we create an artificial thunk and because of -fPIC, ia32 and thunk
    destination which doesn't bind locally can't use a mi thunk.
    The ICE is because during expansion to RTL we see SSA_NAME for a PARM_DECL,
    but the PARM_DECL doesn't have DECL_CONTEXT of the current function.
    This is because duplicate_thunk_for_node creates a new DECL_ARGUMENTS chain
    only if some arguments need modification.
    
    The following patch fixes it by copying the DECL_ARGUMENTS list even if
    the arguments can stay as is, to update DECL_CONTEXT on them.  While for
    mi thunks it doesn't really matter because we don't use those arguments
    in any way, for other thunks it is important.
    
    2023-02-23  Jakub Jelinek  <jakub@redhat.com>
    
            PR middle-end/108854
            * cgraphclones.c (duplicate_thunk_for_node): If no parameter
            changes are needed, copy at least DECL_ARGUMENTS PARM_DECL
            nodes and adjust their DECL_CONTEXT.
    
            * g++.dg/opt/pr108854.C: New test.
    
    (cherry picked from commit 2f1691be517fcdcabae9cd671ab511eb0e08b1d5)

diff --git a/gcc/cgraphclones.c b/gcc/cgraphclones.c
index e4f1c1d4b5e..79b29e524c7 100644
--- a/gcc/cgraphclones.c
+++ b/gcc/cgraphclones.c
@@ -214,7 +214,17 @@ duplicate_thunk_for_node (cgraph_node *thunk, cgraph_node *node)
       body_adj.modify_formal_parameters ();
     }
   else
-    new_decl = copy_node (thunk->decl);
+    {
+      new_decl = copy_node (thunk->decl);
+      for (tree *arg = &DECL_ARGUMENTS (new_decl);
+	   *arg; arg = &DECL_CHAIN (*arg))
+	{
+	  tree next = DECL_CHAIN (*arg);
+	  *arg = copy_node (*arg);
+	  DECL_CONTEXT (*arg) = new_decl;
+	  DECL_CHAIN (*arg) = next;
+	}
+    }
 
   gcc_checking_assert (!DECL_STRUCT_FUNCTION (new_decl));
   gcc_checking_assert (!DECL_INITIAL (new_decl));
diff --git a/gcc/testsuite/g++.dg/opt/pr108854.C b/gcc/testsuite/g++.dg/opt/pr108854.C
new file mode 100644
index 00000000000..9f2d9030f75
--- /dev/null
+++ b/gcc/testsuite/g++.dg/opt/pr108854.C
@@ -0,0 +1,37 @@
+// PR middle-end/108854
+// { dg-do compile { target c++11 } }
+// { dg-options "-O3" }
+// { dg-additional-options "-fPIC" { target fpic } }
+
+struct A { A (int); ~A (); };
+struct B { B (int, bool); ~B (); };
+template <typename T>
+struct C { void m1 (T); void m2 (T &&); };
+class D;
+struct E { virtual void m3 (); };
+template <typename>
+struct F { virtual bool m4 (D &); };
+struct D { virtual D m5 () { return D (); } };
+void foo (void *, void *);
+struct G {
+  int a;
+  C <D *> b;
+  void m4 (D &r) { B l (a, true); r.m5 (); b.m1 (&r); b.m2 (&r); }
+};
+struct H : E, F <int> {
+  template <typename T>
+  H (int, T);
+  bool m4 (D &r) { A l (a); b.m4 (r); if (c) return true; } // { dg-warning "control reaches end of non-void function" }
+  int a;
+  bool c;
+  G b;
+};
+inline void bar (F <int> &p) { D s, t; p.m4 (t); foo (&p, &s); }
+enum I { I1, I2 };
+template <I>
+struct J;
+template <class, class T, class, class, class, class>
+void baz () { int g = 0, h = 0; T i (g, h); bar (i); }
+template <class, int, I T>
+void qux () { baz <int, H, int, int, E, J<T>> (); }
+void corge () { qux <int, I2, I1> (); qux <int, I2, I2> (); }

